import { world, system } from "@minecraft/server";

const commandOnGround = "execute as @a[r=10,tag=clawinvade] at @s run summon la:dash_slashs ^^-1^-3";
const commandOnGround2 = "scoreboard players add @a[tag=clawinvade] clawinvade 1";
const commandOnGround3 = "execute as @a[scores={clawinvade=1..21}] at @a run tag @e[r=9,tag=!clawinvade] add claws";

function isPlayerOnGround(player) {
    const { y } = player.location;
    const blockBelow = world.getDimension("overworld").getBlock({
        x: player.location.x,
        y: Math.floor(y) - 1,
        z: player.location.z
    });
    return blockBelow && blockBelow.typeId !== "minecraft:air";
}

system.runInterval(() => {
    const players = world.getPlayers();
    
    players.forEach(player => {
        if (player.hasTag("clawinvade") && isPlayerOnGround(player)) {
            player.runCommand(commandOnGround);
            player.runCommand(commandOnGround2);
            player.runCommand(commandOnGround3);
        }
    });
}, 2);
const destructionRadius = 100;
const maxBlocks = 50000;
const destructionChance = 0.2;
const verticalRange = 5;

function destroyBlocksAroundEntity(entity) {
    let blocksDestroyed = 0;

    for (let x = -destructionRadius; x <= destructionRadius; x++) {
        for (let z = -destructionRadius; z <= destructionRadius; z++) {
            if (Math.random() < destructionChance && blocksDestroyed < maxBlocks) {
                for (let y = -verticalRange; y <= verticalRange; y++) {
                    try {
                        entity.runCommand(`setblock ~${x} ~${y} ~${z} minecraft:air`);
                        blocksDestroyed++;
                    } catch (e) {}
                }
            }
        }
    }
    entity.removeTag("ultimatesovereigndes");
}

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        if (player.hasTag("ultimatesovereigndes")) {
            destroyBlocksAroundEntity(player);
        }
    }
}, 20);