import { world } from '@minecraft/server';

const cooldowns = {};

function canUseCommand(player, tag, cooldownTime) {
    const playerName = player.name;

    if (!cooldowns[playerName]) {
        cooldowns[playerName] = {};
    }

    const currentTime = Date.now();
    const lastUsedTime = cooldowns[playerName][tag] || 0;

    if (currentTime - lastUsedTime >= cooldownTime) {
        cooldowns[playerName][tag] = currentTime;
        return true;
    }

    return false;
}

function hasItemInInventory(player, itemId) {
    const inventory = player.getComponent('minecraft:inventory').container;
    for (let i = 0; i < inventory.size; i++) {
        const item = inventory.getItem(i);
        if (item && item.typeId === itemId) {
            return true;
        }
    }
    return false;
}

function sendCooldownMessage(player) {
    player.runCommandAsync(`title @s actionbar §0SWORD-COOLDOWN`);
}

world.afterEvents.itemUse.subscribe((eventData) => {
    const player = eventData.source;
    const item = eventData.itemStack.typeId;

    const tagCooldowns = {
        "sskill1": 9000, //Conqueror of hell 
        "sskill2": 20000,
        "sskill3": 150000
    };

    switch (item) {
        case "la:conqueror_of_hell":
            if (hasItemInInventory(player, "la:conqueror_of_hell")) {
                if (player.hasTag("sskills1")) {
                    if (canUseCommand(player, "sskill1", tagCooldowns["sskill1"])) {
                        player.runCommand('function tag @s add purgatoryeruption');
                    } else {
                        sendCooldownMessage(player);
                    }
                }
                if (player.hasTag("sskills2")) {
                    if (canUseCommand(player, "sskill2", tagCooldowns["sskill2"])) {
                        player.runCommand('tag @s add purgatoryslasher');
                    } else {
                        sendCooldownMessage(player);
                    }
                }
                if (player.hasTag("sskills3")) {
                    if (player.hasTag("CIP")) {
                        if (canUseCommand(player, "sskill5", tagCooldowns["sskill5"])) {
                            player.runCommand('tag @s add chaosinpurgatory');
                        } else {
                            sendCooldownMessage(player);
                        }
                    } else {
                        player.runCommand('tell @s "LEARN-WITH-A-PURGATORY-MASTER!"');
                    }
                }
            }
            break;
    }
    
});
   // "conqueror_of_hell" Jujutuooo