import { world } from '@minecraft/server';

const entities = [
    'minecraft:iron_golem',
    'la:runic_guard'
];

const validSwords = [
    'minecraft:iron_sword',
    'minecraft:golden_sword',
    'minecraft:diamond_sword',
    'minecraft:netherite_sword',
    'la:katana'
];

world.afterEvents.entityHitEntity.subscribe((data) => {
    const { damagingEntity, hitEntity } = data;

    if (damagingEntity.typeId !== 'minecraft:player') return;

    const equipment = damagingEntity.getComponent('equippable')?.getEquipment('Mainhand');
    if (!equipment || !validSwords.includes(equipment.typeId)) return;
    if (!entities.includes(hitEntity.typeId)) return;

    damagingEntity.runCommand('tag @s add sword_impact');
    hitEntity.runCommand('particle la:metal_impact_particle ~~1~');
    hitEntity.runCommand('particle la:metal_impact_particle2 ~~1~');
    hitEntity.runCommand('summon la:impact_knockback ~~-6~');
    damagingEntity.runCommand('tag @s remove sword_impact');
});
//katana
world.afterEvents.entityHitEntity.subscribe((data) => { const { damagingEntity, hitEntity } = data; if (damagingEntity.typeId !== 'minecraft:player') return;

const equipment = damagingEntity.getComponent('equippable')?.getEquipment('Mainhand');
if (!equipment || equipment.typeId !== 'la:katana') return;
if (entities.includes(hitEntity.typeId)) return;

let hitState = 1;
if (damagingEntity.hasTag('hit_1')) hitState = 2;
else if (damagingEntity.hasTag('hit_2')) hitState = 3;
else if (damagingEntity.hasTag('hit_3')) hitState = 4;

damagingEntity.runCommand('tag @s remove hit_1');
damagingEntity.runCommand('tag @s remove hit_2');
damagingEntity.runCommand('tag @s remove hit_3');

if (hitState === 1) {
    damagingEntity.runCommand('particle la:sword_slash ^0^1^2');
    damagingEntity.runCommand('particle la:sword_slash ^0^1.5^2.5');
    damagingEntity.runCommand('particle la:sword_slash ^0^2^3');
    damagingEntity.runCommand('tag @s add hit_1');
} else if (hitState === 2) {
    damagingEntity.runCommand('particle la:sword_slash ^-2^1^2');
    damagingEntity.runCommand('particle la:sword_slash ^0^1^2.5');
    damagingEntity.runCommand('particle la:sword_slash ^2^1^2');
    damagingEntity.runCommand('tag @s add hit_2');
} else if (hitState === 3) {
    damagingEntity.runCommand('particle la:sword_slash ^-1^0.5^2');
    damagingEntity.runCommand('particle la:sword_slash ^0^1^2.5');
    damagingEntity.runCommand('particle la:sword_slash ^1^1.5^3');
    damagingEntity.runCommand('tag @s add hit_3');
} else {
    damagingEntity.runCommand('particle la:sword_slash ^0^1^2');
    damagingEntity.runCommand('particle la:sword_slash ^0^1.5^2.5');
    damagingEntity.runCommand('particle la:sword_slash ^0^2^3');
    damagingEntity.runCommand('tag @s add hit_1');
}

damagingEntity.runCommand('execute as @s at @s run tag @s add hit');
damagingEntity.runCommand('execute at @s positioned ^^^3 run damage @e[r=3,tag=!hit,type=!item] 5');

if (Math.random() < 0.05) {
    damagingEntity.runCommand('execute at @s positioned ^^^3 run tag @e[r=3,tag=!hit] add bleeding_1');
}

if (hitEntity.hasTag('bleeding_1') && Math.random() < 0.20) {
    damagingEntity.runCommand('execute at @s positioned ^^^3 run tag @e[r=3,tag=!hit] remove bleeding_1');
    damagingEntity.runCommand('execute at @s positioned ^^^3 run tag @e[r=3,tag=!hit] add bleeding_2');
}

if (hitEntity.hasTag('bleeding_2') && Math.random() < 0.05) {
    damagingEntity.runCommand('execute at @s positioned ^^^3 run tag @e[r=3,tag=!hit] remove bleeding_2');
    damagingEntity.runCommand('execute at @s positioned ^^^3 run tag @e[r=3,tag=!hit] add bleeding_3');
}
damagingEntity.runCommand('execute as @s at @s run tag @s remove hit');
});
// basic swords
const cooldowns = new Map(); const allowedItems = [ 'minecraft:diamond_sword', 'minecraft:netherite_sword', 'minecraft:golden_sword', 'minecraft:iron_sword' ];

world.afterEvents.entityHitEntity.subscribe((data) => { const { damagingEntity, hitEntity } = data; if (damagingEntity.typeId !== 'minecraft:player') return;

const equipment = damagingEntity.getComponent('equippable')?.getEquipment('Mainhand');
if (!equipment || !allowedItems.includes(equipment.typeId)) return;
if (hitEntity.hasTag('hit')) return;

const lastHitTime = cooldowns.get(damagingEntity.id) || 0;
const now = Date.now();
if (now - lastHitTime < 1000) return;
cooldowns.set(damagingEntity.id, now);

let hitState = 1;
if (damagingEntity.hasTag('hit_1')) hitState = 2;
else if (damagingEntity.hasTag('hit_2')) hitState = 3;
else if (damagingEntity.hasTag('hit_3')) hitState = 4;

damagingEntity.runCommand('tag @s remove hit_1');
damagingEntity.runCommand('tag @s remove hit_2');
damagingEntity.runCommand('tag @s remove hit_3');

switch (hitState) {
    case 1:
        damagingEntity.runCommand('particle la:sword_slash ^-1.5^1^1');
        damagingEntity.runCommand('particle la:sword_slash ^1^1.5^2');
        damagingEntity.runCommand('tag @s add hit_1');
        break;
    case 2:
        damagingEntity.runCommand('particle la:sword_slash ^2^0.5^2');
        damagingEntity.runCommand('particle la:sword_slash ^-2^1^2');
        damagingEntity.runCommand('tag @s add hit_2');
        break;
    case 3:
        damagingEntity.runCommand('particle la:sword_slash ^0^1.5^1');
        damagingEntity.runCommand('particle la:sword_slash ^0^2^2');
        damagingEntity.runCommand('tag @s add hit_3');
        break;
    default:
        damagingEntity.runCommand('particle la:sword_slash ^1^1^2');
        damagingEntity.runCommand('particle la:sword_slash ^-1^1^3');
        damagingEntity.runCommand('tag @s add hit_1');
        break;
}

damagingEntity.runCommand('effect @s slowness 1 1');
damagingEntity.runCommand('tag @s add hit');
hitEntity.runCommand('tag @s add hited');
damagingEntity.runCommand('execute at @s positioned ^^^3 run damage @e[r=3,tag=!hit,type=!item] 5');

if (Math.random() < 0.05) {
    damagingEntity.runCommand('execute at @s positioned ^^^3 run tag @e[r=3,tag=!hit] add bleeding_1');
}

if (hitEntity.hasTag('bleeding_1') && Math.random() < 0.20) {
    damagingEntity.runCommand('execute at @s positioned ^^^3 run tag @e[r=3,tag=!hit] remove bleeding_1');
    damagingEntity.runCommand('execute at @s positioned ^^^3 run tag @e[r=3,tag=!hit] add bleeding_2');
}

if (hitEntity.hasTag('bleeding_2') && Math.random() < 0.15) {
    damagingEntity.runCommand('execute at @s positioned ^^^3 run tag @e[r=3,tag=!hit] remove bleeding_2');
    damagingEntity.runCommand('execute at @s positioned ^^^3 run tag @e[r=3,tag=!hit] add bleeding_3');
}

hitEntity.runCommand('tag @s remove hited');
damagingEntity.runCommand('tag @s remove hit');

});

