import { system, world } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent('la_mafangs_spawn_block:trigger', {
    onTick: e => {
      const block = e.block;
      const dimension = block.dimension;
      const players = dimension.getPlayers({ location: block.location, maxDistance: 25 });

      if (players.length > 0) {
        const existingEntities = dimension.getEntities({ location: block.location, maxDistance: 1, type: 'la:mafangs_statue' });

        if (existingEntities.length === 0) {
          dimension.spawnEntity('la:mafangs_statue', { x: block.location.x, y: block.location.y, z: block.location.z });
          dimension.setBlockType(block.location, 'minecraft:air');
          e.block.removeComponent('la_mafangs_spawn_block:trigger');
        }
      }
    },
  });
});